<?php

namespace Teknisa\FIN\Factories;

use Teknisa\Model\Geral\Entities\Empresa;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class EvolucaofluxocaixaFactory {

    protected $connection;
    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    
    public function callProcedureEvolucaoFluxoCaixa($cdempresa, $dtmovfluxo) {
        $procedure = new StoredProcedure($this->entityManager->getConnection(), 'EVOLUCAO_FLUXO_CAIXA');
        $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $cdempresa, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTMOVFLUXO', Param::PARAM_INPUT, $dtmovfluxo, Param::PARAM_TYPE_STR));
        $procedure->execute();
    }
}