<?php 

namespace Teknisa\FIN\Modules\ContaReceber\Factory;

use Doctrine\ORM\EntityManager;

class Rec15000ChequeRecebidoFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getDtProcess($params) {
        $sql = "SELECT DECODE(PG.IDUTILDTPROC, 'S', NVL(PF.DTPROCESSA,SYSDATE), SYSDATE) AS DTPROCESSA
            FROM PARAMFILIAL PF, PARAMGERAL PG
            WHERE PF.CDFILIAL = :CDFILIAL";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();   
    }
    
    public function getCdOrdem($params) {
        $sql = "SELECT NVL  (LPAD(TO_CHAR(MAX(NRLOGCHEQREC) + 1),2,'0')  ,  LPAD(TO_CHAR(1),2,'0' ) ) AS NRLOGCHEQREC
                FROM LOGCHEQUEREC
                WHERE NRCHEQUERECE = :NRCHEQUERECE
                  AND CDBANCHEQREC = :CDBANCHEQREC
                  AND CDAGECHEQREC = :CDAGECHEQREC
                  AND CDCNTCHEQREC = :CDCNTCHEQREC";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getCdApresentacao() {
        $sql = "SELECT NVL  (LPAD(TO_CHAR(MAX(NRBORDERCREC) + 1),10,'0')  ,  LPAD(TO_CHAR(1),10,'0' ) ) AS NRBORDERCREC
                FROM LOGCHEQUEREC";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getApresentacao($params) {
        $sql = "SELECT * 
            FROM LOGCHEQUEREC
                WHERE NRCHEQUERECE = :NRCHEQUERECE
                  AND CDBANCHEQREC = :CDBANCHEQREC
                  AND CDAGECHEQREC = :CDAGECHEQREC
                  AND CDCNTCHEQREC = :CDCNTCHEQREC
                  AND NRLOGCHEQREC = :NRLOGCHEQREC";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getCheque($params) {
        $sql = "SELECT * 
            FROM CHEQUERECE
                WHERE NRCHEQUERECE = :NRCHEQUERECE
                  AND CDBANCHEQREC = :CDBANCHEQREC
                  AND CDAGECHEQREC = :CDAGECHEQREC
                  AND CDCNTCHEQREC = :CDCNTCHEQREC";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getChequesCompensacao($sqlFilter) {
        $sql = "SELECT DISTINCT
               F.NRCHEQUERECE,
               F.CDBANCHEQREC,
               F.CDAGECHEQREC,
               F.CDCNTCHEQREC,
               F.VRCHEQUERECE,
               F.IDSITCHEQREC,
               F.DTCOMCHEQREC,
               (F.VRCHEQUERECE - SUM(E.VRTPRECBOLR)) VRRESTANTE,
               SUM(E.VRTPRECBOLR) VRUTL
            FROM
               (SELECT DISTINCT
                   A.NRCHEQBOLREC,
                   A.CDBANCBOLREC,
                   A.CDAGENBOLREC,
                   A.CDCONTBOLREC
                FROM
                   TPRECBOLETO  A,
                   (SELECT DISTINCT
                       TB.CDFILIAL,
                       TB.NRLANBOLREC
                    FROM
                       TPRECBOLETO  TB
                    WHERE";
        $sql.=$sqlFilter;
        $sql2 = "WHERE
                   A.CDFILIAL    = B.CDFILIAL AND
                   A.NRLANBOLREC = B.NRLANBOLREC) C,
               BOLETRECEBER D,
               TPRECBOLETO  E,
               CHEQUERECE   F
            WHERE
               (E.NRCHEQBOLREC = C.NRCHEQBOLREC) AND
               (E.CDBANCBOLREC = C.CDBANCBOLREC) AND
               (E.CDAGENBOLREC = C.CDAGENBOLREC) AND
               (E.CDCONTBOLREC = C.CDCONTBOLREC) AND
               (E.CDFILIAL     = D.CDFILIAL)     AND
               (E.NRLANBOLREC  = D.NRLANBOLREC)  AND
               (E.NRCHEQBOLREC = F.NRCHEQUERECE) AND
               (E.CDBANCBOLREC = F.CDBANCHEQREC) AND
               (E.CDAGENBOLREC = F.CDAGECHEQREC) AND
               (E.CDCONTBOLREC = F.CDCNTCHEQREC)
            GROUP BY
               F.NRCHEQUERECE,
               F.CDBANCHEQREC,
               F.CDAGECHEQREC,
               F.CDCNTCHEQREC,
               F.VRCHEQUERECE,
               F.IDSITCHEQREC,
               F.DTCOMCHEQREC
            ORDER BY
               F.NRCHEQUERECE,
               F.CDBANCHEQREC,
               F.CDAGECHEQREC,
               F.CDCNTCHEQREC";
        $sql.=$sql2;
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getBoletosCompensacao($sqlFilter) {
        $sql = "SELECT DISTINCT
               D.CDFILIAL,
               D.NRLANBOLREC,
               D.CDCLIENTE,
               D.NRPARCBOLREC,
               D.VRFINALBREC,
               D.CDFILIBAIREC,
               D.NRBAIXAREC,
               D.DTVENBOLREC,
               D.VRBOLREC,
               D.CDREDUCONT,
               D.CDEMPRESA,
               D.IDSTATBREC,
               D.CDTPBAIXAREC,
               F.NMRAZSOCCLIE,
               D.NRORG
            FROM
               (SELECT DISTINCT
                   A.NRCHEQBOLREC,
                   A.CDBANCBOLREC,
                   A.CDAGENBOLREC,
                   A.CDCONTBOLREC
                FROM
                   TPRECBOLETO  A,
                   (SELECT DISTINCT
                       TB.CDFILIAL,
                       TB.NRLANBOLREC
                    FROM
                       TPRECBOLETO  TB
                    WHERE";
        $sql.=$sqlFilter;
        
        $sql2 = "WHERE
                   A.CDFILIAL    = B.CDFILIAL AND
                   A.NRLANBOLREC = B.NRLANBOLREC) C,
               BOLETRECEBER D,
               TPRECBOLETO  E,
               CLIENTE      F
            WHERE
               (E.NRCHEQBOLREC = C.NRCHEQBOLREC) AND
               (E.CDBANCBOLREC = C.CDBANCBOLREC) AND
               (E.CDAGENBOLREC = C.CDAGENBOLREC) AND
               (E.CDCONTBOLREC = C.CDCONTBOLREC) AND
               (E.CDFILIAL     = D.CDFILIAL)     AND
               (E.NRLANBOLREC  = D.NRLANBOLREC)  AND
               (D.CDCLIENTE    = F.CDCLIENTE)
            ORDER BY
               D.DTVENBOLREC,
               D.VRFINALBREC,
               D.CDFILIAL,
               D.NRLANBOLREC";
        $sql.=$sql2;
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function deleteBoleto($params) {
        $sql = "delete from TPRECBOLETO
                where
                  CDFILIAL = :CDFILIAL and
                  NRLANBOLREC = :NRLANBOLREC and
                  NRSEQTPRECBO = :NRSEQTPRECBO";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function saveBoleto($params) {
        $sql = "INSERT INTO TPRECBOLETO
                  (CDFILIAL, NRLANBOLREC, CDTIPORECE,
                   NRSEQTPRECBO, VRTPRECBOLR, NRCHEQBOLREC,
                   CDBANCBOLREC, CDAGENBOLREC, CDCONTBOLREC)
                values
                  (:CDFILIAL, :NRLANBOLREC, :CDTIPORECE,
                   :NRSEQTPRECBO, :VRTPRECBOLR, :NRCHEQBOLREC,
                   :CDBANCBOLREC, :CDAGENBOLREC, :CDCONTBOLREC)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    
}